// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "hh4mfc.h"

#include "MainFrm.h"
#include "winuser.h"

#include "htmlhelp.h"
#include "Techniques.h"

const long CS_SYSMNU_HH_JUMP_TO_URL = 61439;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_TECHNIQUES, OnViewTechniques)
	ON_COMMAND(ID_EXAMPLES_CHMPOPUP, OnExamplesChmpopup)
	ON_COMMAND(ID_EXAMPLES_RESOURCEPOPUP, OnExamplesResourcePopup)
	ON_COMMAND(ID_EXAMPLES_TEXTPOPUP, OnExamplesTextPopup)
	ON_COMMAND(ID_HELP_CONTENTS, OnHelpContents)
	ON_COMMAND(ID_HELP_INDEX, OnHelpIndex)
	ON_COMMAND(ID_HELP_SEARCH, OnHelpSearch)
	ON_COMMAND(ID_HELP_OPENMINUSJUMPTOURL, OnHelpOpenMinusJumpToUrl)
	ON_COMMAND(ID_EXAMPLES_SETWINDOWTYPE, OnExamplesSetWindowType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnViewTechniques() 
{
	CTechniques techDlg;
	techDlg.DoModal();	
}

void CMainFrame::OnExamplesChmpopup() 
{
	HH_POPUP popup ;
	POINT ptPoint ;
	RECT rRect ;
	
	// Set the popup's margins
	rRect.top = -1 ;
	rRect.left = -1 ;
	rRect.bottom = -1 ;
	rRect.right = -1 ;

	GetCursorPos(&ptPoint);

	memset(&popup, 0, sizeof(HH_POPUP));
    popup.cbStruct = sizeof(HH_POPUP);
	popup.hinst = 0;
	popup.idString = 20000;      
    popup.pszText = "";       
    popup.pt = ptPoint;
    popup.clrForeground = RGB(255, 255, 255); 
    popup.clrBackground = RGB(255, 0, 0); 
    popup.rcMargins = rRect;     
    popup.pszFont = "Arial, 8, ascii, Bold, , Underline";

	HtmlHelp(
		0,
        "hh4mfc.chm::/popups.txt",
        HH_DISPLAY_TEXT_POPUP,
        (DWORD)&popup) ;
}

void CMainFrame::OnExamplesResourcePopup() 
{
	HH_POPUP popup ;
	POINT ptPoint ;
	RECT rRect ;

	HINSTANCE hInstApp = AfxGetResourceHandle();
	
	// Set the popup's margins
	rRect.top = -1 ;
	rRect.left = -1 ;
	rRect.bottom = -1 ;
	rRect.right = -1 ;

	GetCursorPos(&ptPoint);

	memset(&popup, 0, sizeof(HH_POPUP));
    popup.cbStruct = sizeof(HH_POPUP);
	popup.hinst = hInstApp;
	popup.idString = 129;      
    popup.pszText = NULL;       
    popup.pt = ptPoint;
    popup.clrForeground = RGB(0, 255, 255); 
    popup.clrBackground = RGB(0, 128, 128); 
    popup.rcMargins = rRect;     
    popup.pszFont = "Arial, 8, ascii, Bold, Italic, ";

	HtmlHelp(
		0,
        NULL,
        HH_DISPLAY_TEXT_POPUP,
        (DWORD)&popup) ;
}

void CMainFrame::OnExamplesTextPopup() 
{
	HH_POPUP popup ;
	POINT ptPoint ;
	RECT rRect ;
	
	// Set the popup's margins
	rRect.top = -1 ;
	rRect.left = -1 ;
	rRect.bottom = -1 ;
	rRect.right = -1 ;

	GetCursorPos(&ptPoint);

	memset(&popup, 0, sizeof(HH_POPUP));
    popup.cbStruct = sizeof(HH_POPUP);
	popup.hinst = 0;
	popup.idString = 0;      
    popup.pszText = "This is a text-based popup.";       
    popup.pt = ptPoint;
    popup.clrForeground = 0; 
    popup.clrBackground = RGB(255, 255, 208); 
    popup.rcMargins = rRect;     
    popup.pszFont = "Arial, 8, ascii, , , ";

	HtmlHelp(
		0,
        NULL,
        HH_DISPLAY_TEXT_POPUP,
        (DWORD)&popup) ;
}

void CMainFrame::OnExamplesSetWindowType() 
{
	HH_WINTYPE WinType ;
	memset(&WinType,0,sizeof(WinType));
	WinType.cbStruct = sizeof(WinType);
	
    // WinType.fUniCodeStrings;

	// Specify the new window type
    WinType.pszType = "New";
	
	// Put together the desired window parameters
    WinType.fsValidMembers = HHWIN_PARAM_PROPERTIES | HHWIN_PARAM_RECT | HHWIN_PARAM_TB_FLAGS | HHWIN_PARAM_STYLES | HHWIN_PARAM_EXSTYLES | HHWIN_PARAM_SHOWSTATE | HHWIN_PARAM_EXPANSION | HHWIN_PARAM_TABPOS;  
    
	// Specify the new window's properties
	WinType.fsWinProperties = HHWIN_PROP_TRI_PANE | HHWIN_PROP_TAB_FAVORITES | HHWIN_PROP_TAB_SEARCH | HHWIN_PROP_TAB_ADVSEARCH | HHWIN_PROP_CHANGE_TITLE; 
    
	// Give the window a caption
	WinType.pszCaption = "Thing";     
    
	// Use any of the styles listed for use with 
	// the CreateWindow API call
	WinType.dwStyles = WS_DLGFRAME; 
	
	// Use any of the extended styles listed for 
	// use with the CreateWindowEx API call
    WinType.dwExStyles = WS_EX_TOOLWINDOW;
	
	// Specify where the window should be
	RECT wndPos ;
	wndPos.top = 20;
	wndPos.left = 10;
	wndPos.right = 620;
	wndPos.bottom = 410;
	
    WinType.rcWindowPos = wndPos;
    
	// Use any of the states listed for use
    // with the ShowWindow API call.
    // You should only use one here
    WinType.nShowState = SW_SHOW;
	
    // WinType.hwndHelp;     
    // WinType.hwndCaller;
    // WinType.hwndToolBar;      
    // WinType.hwndNavigation;   
    // WinType.hwndHTML; 

	// Set the width of the navigation pane
    WinType.iNavWidth = 250;
	
    //WinType.rcHTML;
	
	// Specify the TOC, Index, default, and Home button
    // files as found within the source files for the CHM
    WinType.pszToc = "hh4mfc.chm::/toc.hhc";     
    WinType.pszIndex = "hh4mfc.chm::/index.hhk";   
    WinType.pszFile = "html\\intro.htm";    
    WinType.pszHome = "html\\intro.htm";
    
	// List which toolbar buttons to display
    WinType.fsToolBarFlags = HHWIN_BUTTON_EXPAND | HHWIN_BUTTON_BACK | HHWIN_BUTTON_REFRESH | HHWIN_BUTTON_ZOOM | HHWIN_BUTTON_HOME | HHWIN_BUTTON_JUMP1 | HHWIN_BUTTON_JUMP2; 
    
	// TRUE = don't show the nav pane, and FALSE = show it
	WinType.fNotExpanded = FALSE; 

    //WinType.curNavType; 
    //WinType.idNotify; 

	// List the text and files for the Jump buttons.
    // Notice that, in order to be able to use URL's
    // or other files here, the App.Path stuff is required
    // for use with a CHM-based HTML file. Also, you can't
    // display the Jump buttons when you also have
    // HHWIN_PROP_MENU set in HHWinProperties.
    WinType.pszJump1 = "Jump This";
    WinType.pszJump2 = "Jump That";
    WinType.pszUrlJump1 = "http://mvps.org/htmlhelpcenter";
    WinType.pszUrlJump2 = "http://www.helpware.net";  
	
	// Create the window
	HtmlHelp(
          0,
          "hh4mfc.chm",
          HH_SET_WIN_TYPE,
          (DWORD) &WinType) ;
	
	// Using the same window name, display the CHM.
    // Any implementation of the HTML Help API would work here.
	HtmlHelp(
		0,
        "hh4mfc.chm>New",
        HH_DISPLAY_TOPIC,
        NULL) ;
}

void CMainFrame::OnHelpContents() 
{
	HtmlHelp(
		0,
        "hh4mfc.chm",
        HH_DISPLAY_TOC,
        NULL) ;
}

void CMainFrame::OnHelpIndex() 
{
	HtmlHelp(
		0,
        "hh4mfc.chm",
        HH_DISPLAY_INDEX,
        NULL) ;	
}

void CMainFrame::OnHelpSearch() 
{
	HH_FTS_QUERY q ;

	memset(&q, 0, sizeof(HH_FTS_QUERY));
    q.cbStruct = sizeof(HH_FTS_QUERY);
    q.fUniCodeStrings = FALSE;
    q.pszSearchQuery = "";
    q.iProximity = HH_FTS_DEFAULT_PROXIMITY;
    q.fStemmedSearch = FALSE;
    q.fTitleOnly = FALSE;
    q.fExecute = TRUE;
    q.pszWindow = NULL;

	HtmlHelp(
		0,
        "hh4mfc.chm",
        HH_DISPLAY_SEARCH,
        (DWORD)&q) ;
}

void CMainFrame::OnHelpOpenMinusJumpToUrl() 
{
	HWND h_wnd = HtmlHelp(
		0,
        "hh4mfc.chm",
        HH_DISPLAY_TOC,
        NULL) ;

	HMENU hsysmnu = ::GetSystemMenu(
		h_wnd,
		FALSE) ;

	DeleteMenu(
		hsysmnu,
		CS_SYSMNU_HH_JUMP_TO_URL,
		MF_BYCOMMAND) ;
}
